#!/usr/local/bin/perl5 -w

# This program converts from the 16-bit unicode to UTF-8

BEGIN {
    die "GSDLHOME not set\n" unless defined $ENV{'GSDLHOME'};
    unshift (@INC, "$ENV{'GSDLHOME'}/perllib");
}

use unicode;

if ($ENV{'GSDLOS'} =~ /windows/i) {
    binmode (STDIN); # silly windows
}

$c = "";
$first = 1;
$bigendian = 1;
while (read (STDIN, $c, 2) == 2) {
    $c1 = ord (substr ($c, 0, 1));
    $c2 = ord (substr ($c, 1, 1));
    if ($first) {
	if ($c1 == 0xff && $c2 == 0xfe) {
	    $bigendian = 0;
	} elsif ($c1 == 0xfe && $c2 == 0xff) {
	    $bigendian = 1;
	} else {
	    die "not unicode text\n";
	}
	$first = 0;

    } else {
	$c = ($bigendian) ? ($c1*256+$c2) : ($c2*256+$c1);
	
	print &unicode::unicode2utf8([$c]);
    }
}
